#include "cod.hpp"

#include <string.h>

bool tool_texture(const char *texture, int map_version)
{
    if (tool_textures[map_version])
    {
        unsigned int i = 0;
        while (tool_textures[map_version][i])
        {
            if (!strcmp(tool_textures[map_version][i], texture))
            {
                return true;
            }
            i++;
        }
    }
    return false;
}

bool spawn_classname(const char *classname, int map_version)
{
    if (spawn_classnames[map_version])
    {
        unsigned int i = 0;
        while (spawn_classnames[map_version][i])
        {
            if (!strcmp(spawn_classnames[map_version][i], classname))
            {
                return true;
            }
            i++;
        }
    }
    return false;
}

const char *cod1_tool_textures[] =
{
    "$additive",
    "$glare_blind",
    "$line",
    "$opaque",
    "$point",
    "descript",
    "aitrig",
    "blank",
    "case",
    "case1024",
    "case1024x512",
    "case256",
    "case256x1024",
    "case512",
    "case512x1024",
    "clipfoliage",
    "metal@temp",
    "nodraw_notsolid",
    "nosight_noclip",
    "return_ai_trigger",
    "return_spawner_trigger",
    "spawner_trigger",
    "ai_nopass",
    "ai_nopasslarge",
    "ai_nosight",
    "areaportal",
    "blackish",
    "case1024x128",
    "caulk",
    "clip",
    "clip_metal",
    "clip_nosight",
    "clip_nosight_metal",
    "clipfull",
    "clipmissile",
    "clipmonster",
    "clipplayer",
    "clipshot",
    "clipweap",
    "clipweap_glass",
    "clusterportal",
    "gridblock",
    "hint",
    "hood",
    "ladder",
    "lightgrid",
    "mirror",
    "mirror1",
    "mirror1a",
    "nodraw",
    "nodraw_decal",
    "occluder",
    "origin",
    "portal",
    "portalcaulk",
    "portalnodraw",
    "shadow",
    "skip",
    "terrain",
    "terrain2",
    "trigger",
    "vehicleclip",
    "water",
    0
};

const char *cod2_tool_textures[] =
{
    "$additive",
    "$glare_blind",
    "$line",
    "$opaque",
    "$point",
    "aa_default",
    "aitrig",
    "ambient",
    "bcs",
    "black",
    "caulk",
    "caulk_shadow",
    "clip",
    "clip_ai",
    "clip_foliage",
    "clip_full",
    "clip_metal",
    "clip_missile",
    "clip_nosight",
    "clip_nosight_dirt",
    "clip_nosight_metal",
    "clip_nosight_nothing",
    "clip_nosight_novehicle",
    "clip_nosight_rock",
    "clip_player",
    "clip_snow",
    "clip_vehicle",
    "clip_water",
    "clip_water_player",
    "clip_weap",
    "clip_weap_glass",
    "escort",
    "goal_volume",
    "hint",
    "kill",
    "ladder",
    "lightmap_blue",
    "lightmap_cyan",
    "lightmap_gray",
    "lightmap_green",
    "lightmap_purple",
    "lightmap_red",
    "lightmap_yellow",
    "mantle_on",
    "mantle_over",
    "mine",
    "nodraw",
    "nodraw_decal",
    "nodraw_notsolid",
    "nosight_noclip",
    "occluder",
    "origin",
    "portal",
    "portal_debug_solid",
    "portal_debug_trans",
    "portal_nodraw",
    "region",
    "return_ai_trigger",
    "return_spawner_trigger",
    "skip",
    "smoke",
    "spawner_trigger",
    "stopspawn",
    "tool_transparent",
    "traverse",
    "trigger",
    "volume",
    "white",
    "white_nocull",
    "white_nocull_offset",
    0
};

const char *cod4_tool_textures[] =
{
    "$additive",
    "$line",
    "$line_nodepth",
    "$opaque",
    "$point",
    "aa_default",
    "aitrig",
    "ambient",
    "autosave",
    "auto_adjust",
    "bcs",
    "caulk",
    "caulk_shadow",
    "clip",
    "clip_ai",
    "clip_foliage",
    "clip_full",
    "clip_magic_jeepride",
    "clip_metal",
    "clip_missile",
    "clip_nosight",
    "clip_nosight_dirt",
    "clip_nosight_for_bridge_on_jeepride_fire_clip",
    "clip_nosight_metal",
    "clip_nosight_nothing",
    "clip_nosight_novehicle",
    "clip_nosight_rock",
    "clip_player",
    "clip_shot_block",
    "clip_snow",
    "clip_vehicle",
    "clip_water",
    "clip_water_player",
    "clip_weap",
    "clip_weap_glass",
    "compass_fov",
    "escort",
    "flag",
    "fog",
    "friendly_respawn",
    "goal_volume",
    "gray",
    "hint",
    "indoor_outdoor",
    "kill",
    "ladder",
    "lightgrid_sky",
    "lightgrid_volume",
    "lightmap_blue",
    "lightmap_cyan",
    "lightmap_gray",
    "lightmap_green",
    "lightmap_purple",
    "lightmap_red",
    "lightmap_yellow",
    "light_portal",
    "mantle_on",
    "mantle_over",
    "mine",
    "mortar_off",
    "mortar_on",
    "nodraw",
    "nodraw_decal",
    "nodraw_glass",
    "nodraw_notsolid",
    "nosight_noclip",
    "origin",
    "physics_geometry",
    "portal",
    "portal_debug_solid",
    "portal_debug_trans",
    "portal_nodraw",
    "region",
    "return_ai_trigger",
    "return_spawner_trigger",
    "skip",
    "smoke",
    "smoothing_hard",
    "smoothing_smooth",
    "smoothing_smooth_other",
    "spawner_trigger",
    "stopspawn",
    "tool_transparent",
    "traverse",
    "trigger",
    "trigger_damage",
    "trigger_hint",
    "trigger_vision",
    "unlock",
    "vehiclegate",
    "vehicle_trigger",
    "volume",
    "white_additive",
    "white_multiply",
    "white_nocull",
    "white_nocull_offset",
    "white_tools",
    "zfaux_wall",
    0
};

const char *cod5_tool_textures[] =
{
    "$additive",
    "$additive_nodepth",
    "$line",
    "$line_nodepth",
    "$opaque",
    "$point",
    "aa_default",
    "aitrig",
    "ambient",
    "autosave",
    "auto_adjust",
    "bcs",
    "caulk",
    "caulk_shadow",
    "clip",
    "clip_ai",
    "clip_foliage",
    "clip_full",
    "clip_metal",
    "clip_missile",
    "clip_missile_nosight",
    "clip_missile_nosight_dirt",
    "clip_missile_nosight_metal",
    "clip_missile_nosight_novehicle",
    "clip_missile_nosight_rock",
    "clip_missile_nosight_wood",
    "clip_missile_no_player",
    "clip_nosight",
    "clip_nosight_dirt",
    "clip_nosight_metal",
    "clip_nosight_nothing",
    "clip_nosight_novehicle",
    "clip_nosight_rock",
    "clip_nosight_wood",
    "clip_player",
    "clip_snow",
    "clip_vehicle",
    "clip_water",
    "clip_water_player",
    "clip_weap",
    "clip_weap_glass",
    "clip_wood",
    "compass_fov",
    "escort",
    "flag",
    "fog",
    "friendly_respawn",
    "goal_volume",
    "gray",
    "hint",
    "indoor_outdoor",
    "kill",
    "ladder",
    "lightgrid_sky",
    "lightgrid_volume",
    "lightmap_blue",
    "lightmap_cyan",
    "lightmap_gray",
    "lightmap_green",
    "lightmap_purple",
    "lightmap_red",
    "lightmap_yellow",
    "light_portal",
    "mantle_on",
    "mantle_over",
    "mine",
    "mortar_off",
    "mortar_on",
    "mount",
    "mount_mantle_on",
    "mount_mantle_over",
    "music_trigger",
    "nodraw",
    "nodraw_decal",
    "nodraw_notsolid",
    "nosight_noclip",
    "occlusion",
    "origin",
    "physics_geometry",
    "portal",
    "portal_debug_solid",
    "portal_debug_trans",
    "portal_nodraw",
    "procedural_grass",
    "region",
    "return_ai_trigger",
    "return_spawner_trigger",
    "skip",
    "smoke",
    "smoothing_hard",
    "smoothing_smooth",
    "smoothing_smooth_other",
    "sound_trigger",
    "spawner_trigger",
    "stopspawn",
    "tool_transparent",
    "traverse",
    "trigger",
    "trigger_damage",
    "trigger_hint",
    "trigger_vision",
    "undertow",
    "unlock",
    "vehiclegate",
    "vehicle_trigger",
    "volume",
    "white_additive",
    "white_multiply",
    "white_nocull",
    "white_nocull_offset",
    "white_tools",

    "ch_godray01",
    "ch_godray_bright",
    "ch_godray_fire",
    "ch_hotspot01",
    "ch_hotspot02",
    "event1",
    "event2",
    "event3",
    "event4",
    "event5",
    "event6",
    "event7",
    "event8",
    "global_invisible",
    "godray_ber2",
    "hdrportal_darken",
    "hdrportal_darken_more",
    "hdrportal_lighten",
    "lst_glow",
    "pel1_glow",
    "temp_cover",
    0
};

const char **tool_textures[] =
{
    0,
    cod1_tool_textures,
    cod2_tool_textures,
    0,
    cod4_tool_textures,
    cod5_tool_textures,
    0
};

////////////////////////////////////////////////////////////////

const char *cod1_spawn_classnames[] =
{
    0
};

const char *cod2_spawn_classnames[] =
{
    "mp_tdm_spawn",
    "mp_dm_spawn",
    "mp_global_intermission",
    "mp_ctf_spawn_allied",
    "mp_ctf_spawn_axis",
    "mp_sd_spawn_defender",
    "mp_sd_spawn_attacker",
    0
};

const char *cod4_spawn_classnames[] =
{
    0
};

const char *cod5_spawn_classnames[] =
{
    0
};

const char **spawn_classnames[] =
{
    0,
    cod1_spawn_classnames,
    cod2_spawn_classnames,
    0,
    cod4_spawn_classnames,
    cod5_spawn_classnames,
    0
};
